;==========================================
;MUIS.ASM           (c)1993 Wagemakers Staf
;==========================================
		.MODEL SMALL
		.CODE
		INCLUDE vgabox.inc
		public knop_uit
;------------------------------------------------
;drukknop naar boven
;ax = knopnummer
;------------------------------------------------
knop_uit        PROC    NEAR                
		push ax
		push bx
		push cx
		push dx
		call knop_kor
		call muis_uit
		@line ax,bx,cx,bx,15
		@line ax,bx,ax,dx,15
		@line ax,dx,cx,dx,0
		@line cx,bx,cx,dx,0
		call muis_aan
		pop dx
		pop cx
		pop bx
		pop ax
		ret
knop_uit        ENDP
		public knop_in
;------------------------------------------------
;drukknop induwen
;ax = knopnummer
;------------------------------------------------
knop_in         PROC    NEAR                
		push ax
		push bx
		push cx
		push dx
		call knop_kor
		call muis_uit
		@line ax,bx,cx,bx,0
		@line ax,bx,ax,dx,0
		@line ax,dx,cx,dx,15
		@line cx,bx,cx,dx,15
		call muis_aan
		pop dx
		pop cx
		pop cx
		pop ax
		ret
knop_in         ENDP
		public knop_kor
;--------------------------------------------------
;rekent de knop kordinaten uit
;aanroep : ax = nr van de knop
;antwoord: ax,bx = x1,y1  cx,dx = x2,y2
;--------------------------------------------------
knop_kor        PROC    NEAR                
		push si
		push ds
		push ax
		mov ax,@data
		mov ds,ax
		mov si,word ptr offset_wijzer
		mov ax,word ptr seg_wijzer
		mov ds,ax
		pop ax
		add si,4
		mov dx,0
		mov cx,8
		mul cx
		add si,ax
		mov ax,[si]
		add si,2
		mov bx,[si]
		add si,2
		mov cx,[si]
		add si,2
		mov dx,[si]
		pop ds
		pop si
		ret
knop_kor        ENDP

		PUBLIC  muis_knop_init
;---------------------------------------------
;Schakelt de muis_knop routine in.
;aanroep :   call muis_knop_init
;            ds:bx -> wijzer naar de muis_knop
;                     parameters.
;parmeterstabel:
;dw ?                    <- kontrole var.
;dw <aantal>             <- aantal knoppen
;dw <x1>,<y1>,<x2>,<y2>  <- par. voor knop1
;dw <x1>,<y1>,<x2>,<y2>  <- par. voor knop2
;enz ..
;---------------------------------------------
muis_knop_init  PROC    NEAR
		push ax
		push bx
		push cx
		push dx
		push ds
		push es
		mov  ax,ds
		mov  es,ax
		mov  ax,@data
		mov  ds,ax
		mov  word ptr ds:[seg_wijzer],es
		mov  word ptr ds:[offset_wijzer],bx
		pop  es
		pop  ds
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret  
muis_knop_init  ENDP
		PUBLIC muis_knop
;----------------------------------------------
;PROCEDURE welke aanroepen wordt door de muis-
;driver, als de linker knop losgelaten wordt!
;Geeft terug:
;op DS:BX (ingesteld door muis_knop_init)
;eerste positie : nummer van het selekteerde menu
;                 0FFFFh bij geen selektie
;----------------------------------------------
muis_knop       PROC NEAR  
		push ax
		push bx
		push cx
		push dx
		push si
		push di
		push ds
		push es
		pushf
		mov  ax,@data
		mov  ds,ax
		mov  bx,word ptr ds:[offset_wijzer]
		mov  ax,word ptr ds:[seg_wijzer]
		mov  ds,ax
		
		mov  [bx],0FFFFh
		push bx
		call muis_pos
		cmp  bx,1
		pop  bx
		je   muis_knop03
		jmp  muis_knop_ok
muis_knop03:
		mov  ax,cx
		add  bx,2
		mov  cx,[bx]
		add  bx,2
muis_knop01:
		call kon_muis_knop
		jnc  muis_knop02
		mov  bx,ds:[offset_wijzer]
		add  bx,2
		mov  ax,[bx]
		sub  ax,cx
		sub  bx,2
		mov  [bx],ax
		jmp  muis_knop_ok
muis_knop02:
		add  bx,8
		loop muis_knop01
muis_knop_ok:
		popf
		pop  es
		pop  ds
		pop  di
		pop  si
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret  
muis_knop       ENDP
kon_muis_knop   PROC NEAR
		cmp ax,[bx]
		jl  kon_muis_knop01
		cmp dx,[bx+2]
		jl  kon_muis_knop01
		cmp ax,[bx+4]
		jg  kon_muis_knop01
		cmp dx,[bx+6]
		jg  kon_muis_knop01
		stc
		jmp kon_muis_knop_ok
kon_muis_knop01:
		clc
kon_muis_knop_ok:
		ret
kon_muis_knop       ENDP
;INT 33 - MS MOUSE - DEFINE INTERRUPT SUBROUTINE PARAMETERS
;       AX = 000Ch
;       CX = call mask
;            bit 0 call if mouse moves
;            bit 1 call if left button pressed
;            bit 2 call if left button released
;            bit 3 call if right button pressed
;            bit 4 call if right button released
;            bit 5 call if middle button pressed (Mouse Systems/Logitech mouse)
;            bit 6 call if middle button released (Mouse Sys/Logitech mouse)
;       ES:DX -> FAR routine
;Notes: when the subroutine is called, it is passed the following values:
;         AX = condition mask (same bit assignments as call mask)
;         BX = button state
;         CX = cursor column
;         DX = cursor row
;         SI = horizontal mickey count
;         DI = vertical mickey count
;       some versions of the Microsoft documentation incorrectly state that CX
;         bit 0 means call if mouse cursor moves, and swap the meanings of SI
;         and DI
	   .CODE
int_33h    PROC   NEAR
	   push   bx
	   push   cx
	   push   dx                           
	   mov    bx,0000                      
	   mov    cx,bx                        
	   mov    dx,bx                        
	   int    33h                           
	   pop    dx                           
	   pop    cx                           
	   pop    bx                           
	   ret                                 
int_33h     ENDP     
;------------------------------------------           
;maak de muis zichtbaar
;aanroep: call muis_aan       
;------------------------------------------           
	   PUBLIC muis_aan
muis_aan   PROC   NEAR
	   push   ax                           
	   mov    ax,0001                      
	   call   int_33h                         
	   pop    ax                           
	   ret                                 
muis_aan   ENDP             
;------------------------------------------           
;maak de muis onzichtbaar
;aanroep: call muis_uit       
;------------------------------------------           
	   PUBLIC muis_uit
muis_uit   PROC NEAR           
	   push   ax                           
	   mov    ax,0002                      
	   call   int_33h                         
	   pop    ax                           
	   ret                                 
muis_uit   ENDP     
;------------------------------------------           
;initialiseert de muis
;aanroep: call muis_init       
;------------------------------------------           
	   PUBLIC muis_init
muis_init  PROC NEAR  
	   push   ax                           
	   mov    ax,0000                      
	   call   int_33h                         
	   pop    ax                           
	   ret                                 
muis_init  ENDP 
;------------------------------------------           
;lees de muis positie
;aanroep: call muis_kor       
;antwoord: 
;bx:    0 -> geen enkele muisknop ingedrukt.
;       1 -> linker muisknop ingedrukt.
;       2 -> rechter muisknop ingedrukt.
;       4 -> middelste muisknop ingedrukt.
;dx:    y-positie van de muiskursor
;cx:    x-positie van de muiskursor
;------------------------------------------           
	   PUBLIC muis_pos
muis_pos   PROC NEAR
	   push ax
	   mov ax,03h
	   int 33h
	   pop ax
	   ret
muis_pos   ENDP
;------------------------------------------           
;lees de muis positie
;aanroep: call muis_kor       
;antwoord: 
;bx:    0 -> geen enkele muisknop ingedrukt.
;       1 -> linker muisknop ingedrukt.
;       2 -> rechter muisknop ingedrukt.
;       4 -> middelste muisknop ingedrukt.
;dl:    x-positie van de muiskursor
;dh:    y-positie van de muiskursor
;------------------------------------------           
	   PUBLIC muis_kor
muis_kor   PROC NEAR       
	   push   ax                           
	   push   cx                           
	   mov    ax,0003                      
	   int    33h                           
	   mov    ax,dx                        
	   push   cx                           
	   mov    cx,0008                      
	   mov    dx,0000                      
	   div    cx                           
	   pop    cx                           
	   mov    dh,al                        
	   mov    ax,cx                        
	   mov    cx,0008                      
	   push   dx                           
	   mov    dx,0000                      
	   div    cx                           
	   pop    dx                           
	   mov    dl,al                        
	   pop    cx                           
	   pop    ax                           
	   ret                                 
muis_kor   ENDP
	   PUBLIC dis_muis
;------------------------------------------           
;disabled de muis driver
;aanroep : call dis_muis
;------------------------------------------           
dis_muis   PROC NEAR                
	   push ax
	   push bx
	   push es
	   mov ax,001Fh
	   int 33h
	   pop es
	   pop bx
	   pop ax
	   ret
dis_muis   ENDP
	   PUBLIC en_muis
;------------------------------------------           
;enabled de muis driver
;aanroep : call en_muis
;------------------------------------------           
en_muis    PROC NEAR     
	   push ax
	   mov ax,0020h
	   int 33h
	   pop ax
	   ret
en_muis    ENDP     
	   .DATA
seg_wijzer      dw ?
offset_wijzer   dw ?
	   END
